# jQuery Fundamentals Training Material #
This repository contains evolving source material for my jQuery Fundamentals class, including exercises, solutions, and a web-based book. 

If you're looking for the latest release of the book, download the [most recent tag](http://github.com/rmurphey/jqfundamentals/downloads) and navigate to /book/release/html/. 

## Contributing ##
I have released this material under the Creative Commons Attribution-Share Alike 3.0 US license because I am eager to see other people contribute to it. Pull requests are welcome and encouraged!

The content of the book is written in [DocBook 5.0](http://www.docbook.org/), which is slightly painful to write in due to the lack of good free XML editors, but which generates all sorts of outputs, including HTML and PDF. I used the free version of [XMLEditor](http://www.xmlmind.com/xmleditor/) to generate the chapter files. 

If you're interested in contributing but don't want to deal with DocBook, let me know and we can work something out. Also, if you have existing content that you think would be good to include in the book, let me know that too! You will, of course, be credited for any contributions.

Following is a to-do list for the book and the project.

### TODO ###

#### Book Chapters ####
*	Writing testable code
*	Unit testing with QUnit
*	Performance best practices (refer to http://paulirish.com/perf)
* 	Plugin authoring
* 	Build tools & dependency management [RequireJS](http://requirejs.org/)
*	Custom Events

#### General ####
*	The PDF output is decent but has issues. If you're interested in solving them, please do :) For now I consider it good enough, though.
*	Also, since I write JavaScript, not shell scripts, the shell scripts for generating the HTML and PDF could undoubtedly be improved if you're so inclined, especially because there's some duplication between them.

## Using This Material ##
Per the license, you are welcome to use this material; if you're using it to teach a class, I'd love for you to let me know about it.

## Generating the HTML ##
From the /book directory, run

`./scripts/install.sh`

Then, run

`./scripts/publish.sh`

`./scripts/publish-pdf.sh`

# Copyright & Licensing #
This material is licensed by Rebecca Murphey under the [Creative Commons Attribution-Share Alike 3.0 United States license](http://creativecommons.org/licenses/by-sa/3.0/us/). You are free to copy, distribute, transmit, and remix this work, provided you attribute the work to Rebecca Murphey as the original author and reference [this repository](http://github.com/rmurphey/jqfundamentals). If you alter, transform, or build upon this work, you may distribute the resulting work only under the same, similar or a compatible license. Any of the above conditions can be waived if you get permission from the copyright holder. For any reuse or distribution, you must make clear to others the license terms of this work. The best way to do this is with a link to the [Creative Commons Attribution-Share Alike 3.0 United States license](http://creativecommons.org/licenses/by-sa/3.0/us/).
